# USAGE
# mkdir /var/www/product_update
# ensure auto_update.sh script located in scripts/auto_update.sh is in /var/www/product_update
# cd /var/www/product_update
# sh /var/www/product_update/auto_update.sh http://192.168.110.5/ova/cli_with_aUU_dev/tui-4.3.0.285-542eea8-APM.tar.gz

current_tui_url=$1

sudo mkdir /var/www/product_update
sudo mkdir /var/www/html
sudo cp -Rf update_main.sh /var/www/product_update/

if [[ "$main_product" == "aco" ]]; then
    sudo mkdir /opt/akkadian
    sudo mkdir /opt/akkadian/data
    sudo mkdir /opt/akkadian/aco-server
elif [[ "$main_product" == "apm" ]]; then
    sudo mkdir /var/www/html/pme
else
    sudo mkdir /var/www/html/acm
fi

echo "updating dnf..."
sudo dnf makecache --refresh

# install wget
echo "installing wget..."
sudo dnf -y install wget

# install jq
echo "installing jq..."
sudo dnf -y install jq

# install akkadianuser
echo $'\n' "Creating akkadianuser..."
adduser akkadianuser
echo "akkadianpassword" | passwd --stdin akkadianuser
gpasswd -a akkadianuser wheel

echo $'\n' "# Akkadian user configuration" >> /etc/sudoers
echo "akkadianuser ALL=(ALL) ALL" >> /etc/sudoers
echo "%akkadianuser   ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers


echo "Finally installing cli!!!"
sudo sh auto_update.sh $current_tui_url

cd /var/www/product_update/

sudo dnf -y install python39

cd /home/akkadianuser/packages/
tar -zxvf click.tar.gz
cd click
sudo pip3 install Click-7.0-py2.py3-none-any.whl -f ./ --no-index --no-deps

cd /home/akkadianuser/packages/
sudo pip3 install netifaces

tar -zxvf python-pam.tar.gz
sudo pip3 install python_pam-1.8.4-py2.py3-none-any.whl -f ./ --no-index --no-deps
cd /home/akkadianuser/

python3 setup.py install

cat /dev/null > /home/akkadianuser/.bashrc

printf "# .bashrc
trap "" 2
trap "" 20
# Source global definitions
if [ -f /etc/bashrc ]; then
        . /etc/bashrc
fi

# Uncomment the following line if you don't like systemctl's auto-paging feature:
# export SYSTEMD_PAGER=

# User specific aliases and functions
export PATH+=:/usr/local/bin
export EDITOR=nano

sudo /usr/local/bin/akkadianAppManager menu

exit" > /home/akkadianuser/.bashrc



