#!/usr/bin/env bash
date=$(date)
sudo echo "Initializing aco_web installation on: $date" >/home/akkadianuser/logs/aco_web_installation.log

web_updater_file="acow-webapp.war"
current_web_folder=/opt/tomcat/latest/webapps
current_tmp_release_folder=/opt/akkadian/data/tmp

code=0
msg=""

if [[ -f /opt/tomcat/latest/webapps/acow-webapp/WEB-INF/applicationContext-mongo.xml ]]; then
  resultcpmongo=$(sudo yes | cp -Rf /opt/tomcat/latest/webapps/acow-webapp/WEB-INF/applicationContext-mongo.xml /opt/akkadian/data/tmp/applicationContext-mongo.xml 2>&1)
  codemongo=$?

  if [ ${codemongo} -ne 0 ]; then
    msg="${msg}\n ERROR: Can't Copy applicationContext-mongo.xml to /opt/akkadian/data/tmp/applicationContext-mongo.xml"
  fi
else
  if [[ -d /opt/tomcat/latest/webapps/acow-webapp ]]; then
    msg="${msg}\n WARNING: applicationContext-mongo.xml doesn't exist on acow-webapp "
  else
    msg="${msg}\n WARNING: doesn't exist acow-webapp "
  fi
fi

echo "$msg" >>/home/akkadianuser/logs/aco_web_installation.log

result=$(sudo ps aux | grep tomcat | grep -v grep | awk '{print $2}' | xargs -r kill -9)
sleep 3
result=$(sudo sh /home/akkadianuser/scripts/stop_tomcat.sh)

COUNTER=0
while [ $COUNTER -lt 1 ]; do
  # shellcheck disable=SC1102
  statustomcat=$(sudo systemctl status tomcat.service)

  if [[ "$statustomcat" != *"Active: active"* ]]; then
    let COUNTER=COUNTER+1
  fi
  echo "Waiting Tomcat to stop... " >>/home/akkadianuser/logs/aco_web_installation.log
  sleep 1
done

if [[ -f ${current_tmp_release_folder}/${web_updater_file} ]]; then
  if [[ -f ${current_web_folder}/${web_updater_file} ]]; then
    result=$(sudo rm ${current_web_folder}/${web_updater_file}) &
    wait $!
  fi

  if [[ -d ${current_web_folder}/acow-webapp ]]; then
    result=$(sudo rm -Rf ${current_web_folder}/acow-webapp) &
    wait $!
  fi

  result=$(sudo mv ${current_tmp_release_folder}/${web_updater_file} ${current_web_folder}/)
  sleep 3

  msgdrop=$(sudo mysql --defaults-extra-file=/home/akkadianuser/.my_aco.cnf -e "DROP DATABASE fp;" 2>&1)
  codedrop=$?
  msgcreate=$(sudo mysql --defaults-extra-file=/home/akkadianuser/.my_aco.cnf -e "CREATE DATABASE fp;" 2>&1)
  codecreate=$?

  result=$(sudo chmod -R 0666 /opt/tomcat/latest/logs)
  result=$(sudo rm -rf /opt/tomcat/latest/logs/*)

  if [[ -f /opt/akkadian/data/tmp/applicationContext-mongo.xml ]]; then
    if [[ -d /opt/tomcat/latest/webapps/acow-webapp/WEB-INF/ ]]; then
      resultcpmongo=$(sudo yes | cp -Rf /opt/akkadian/data/tmp/applicationContext-mongo.xml /opt/tomcat/latest/webapps/acow-webapp/WEB-INF/applicationContext-mongo.xml 2>&1)
      codemongo=$?

      if [ $codemongo -ne 0 ]; then
        msg="${msg}\n ERROR: Can't Copy applicationContext-mongo.xml "
      fi

    else
      msg="${msg}\n WARNING: doesn't exist on acow-webapp "
    fi
  fi
else
  msg="${msg}\n ERROR: ${current_tmp_release_folder}/${web_updater_file} doesn't exist "
  resultmvwar=1
fi

result=$(sudo systemctl start tomcat.service)
sleep 1

COUNTER=0
while [ $COUNTER -lt 1 ]; do
  # shellcheck disable=SC1102
  statustomcat=$(sudo systemctl status tomcat.service)

  if [[ "$statustomcat" == *"Active: active"* ]]; then
    let COUNTER=COUNTER+1
  fi
  echo "Waiting Tomcat to start... " >>/home/akkadianuser/logs/aco_web_installation.log
  sleep 1
done
code=0

echo "Error Messages: ${msg}" >>/home/akkadianuser/logs/aco_web_installation.log
exit $code
