#!/usr/bin/env bash

pcsd_status=$(pcs status 2>&1)
if [[ "$pcsd_status" != "Error: cluster is not currently running on this node" ]]
then
    MASTER=$(sudo pcs status | grep RS_VIP_Akkadian | awk -F ' ' '{print $4}')
    NODES=$(sudo pcs status | grep Online: | awk -F : '{print $2}')

    gpg -d -q --batch --passphrase Akkadian /home/akkadianuser/.sshpassword_pme_cm.gpg > /home/akkadianuser/.sshpass
    IFS=$' '
    for j in $NODES
        do
            if [[ ( "$j" != "[" ) && ( "$j" != "]" ) && ("$j" != "$MASTER") ]]
            then
                sshpass -f /home/akkadianuser/.sshpass ssh -o StrictHostKeyChecking=no root@$j 'mysql --defaults-extra-file=/home/akkadianuser/.my.cnf -u root -e "SHOW SLAVE STATUS\G;" | grep "Master_Host\|Slave_IO_Running"'
            fi
    done
    truncate -s 0 /home/akkadianuser/.sshpass
    sudo rm -Rf /home/akkadianuser/.sshpass


else
    NODES=$(head -n 1 /home/akkadianuser/load_balancer.config)
    mysql --defaults-extra-file=/home/akkadianuser/.my.cnf -u root -e "SHOW SLAVE STATUS\G;" | grep 'Master_Host\|Slave_IO_Running'
fi




