#!/bin/bash
#   PME installer scrip
#   parameters:
#           number of current release
#           number of the previous release (release to backup)
#           path and name of the zip installer file


#paramas current release version

old_release=$1

if [[ ! -d /home/akkadianuser/tmp ]]; then
    mkdir /home/akkadianuser/tmp
fi

if [[ ! -d /home/akkadianuser/tmp/pme_installation ]]; then
    mkdir /home/akkadianuser/tmp/pme_installation
fi

current_tmp_release_folder=/home/akkadianuser/tmp/pme_installation
current_release_zip_name=$(echo "$2" | sed -r "s/\x1B\[([0-9]{1,3}((;[0-9]{1,3})*)?)?[m|K]//g");

backup_directory=/home/backups/pme
backup_release_directory=$backup_directory"/"$old_release

if [ -d $backup_directory ];then
    rm -rf $backup_directory
fi

if [ ! -e $backup_directory ];then
    mkdir -p $backup_directory
fi

if [ ! -e "$backup_release_directory" ];then
    mkdir "$backup_release_directory"
fi

if [ -e $current_tmp_release_folder ];then
    rm -Rf $current_tmp_release_folder
fi

if [ ! -e $current_tmp_release_folder ];then
    mkdir $current_tmp_release_folder
fi


#taking db backups
echo "Starting the installation of Akkadian PM" > /home/akkadianuser/logs/pme_installation.log
date >> /home/akkadianuser/logs/pme_installation.log

echo "Tacking backups" >> /home/akkadianuser/logs/pme_installation.log
mysqldump --defaults-extra-file=/home/akkadianuser/.my.cnf -u root --max_allowed_packet=1G --all-databases --events > "$backup_release_directory/$old_release.sql"

#taking pme backups
echo 'making pme software backup...'
sudo tar -zcf "$backup_release_directory/$old_release.tar.gz" -C / var/www/html/pme


#Do we need to download the file?
if [[ ( $current_release_zip_name == "http"* ) || ( $current_release_zip_name == "ftp"* ) ]]; then
    echo 'getting external file' >> /home/akkadianuser/logs/pme_installation.log
    sudo wget "$current_release_zip_name" -P $current_tmp_release_folder/
    echo 'unzipping current file' >> /home/akkadianuser/logs/pme_installation.log
    sudo unzip $current_tmp_release_folder/"$(basename $current_release_zip_name)" -d $current_tmp_release_folder/
else
    echo 'getting local file' >> /home/akkadianuser/logs/pme_installation.log
    sudo cp -Rf "$current_release_zip_name" $current_tmp_release_folder
    sudo unzip -qo $current_tmp_release_folder/"$(basename $current_release_zip_name)" -d $current_tmp_release_folder/
fi

echo 'Copying source code' >> /home/akkadianuser/logs/pme_installation.log
\cp -rf $current_tmp_release_folder/PME/* /var/www/html/pme/
\cp -rf $current_tmp_release_folder/PME/.htaccess /var/www/html/pme/.htaccess

echo 'Changing permissions' >> /home/akkadianuser/logs/pme_installation.log
sudo chown apache:root /var/www/html/pme/ -R
sudo chmod 775 /var/www/html/pme/ -R

if [ -f /var/www/html/pme/migrations_prod.php ]; then
  rm  /var/www/html/pme/migrations_prod.php -f
fi

if [[ -s /var/www/html/pme/database/microsoft/phinx.yml ]]; then
    if [[ ! -d /var/lib/database/microsoft/ ]]; then
        mkdir -p /var/lib/database/microsoft/
    fi

    \mv -f /var/www/html/pme/database/microsoft/phinx.yml /var/lib/database/microsoft/phinx.yml
    chown -R apache:root /var/lib/database/microsoft/phinx.yml
    chmod 775 /var/lib/database/microsoft/phinx.yml
fi

echo 'Running migrations' >> /home/akkadianuser/logs/pme_installation.log
cd /var/www/html/pme/database && php migrations_prod.php