# https://stackoverflow.com/a/4896288

from src.kb_handler.kbhit_manager import (KBHit, getch)
from subprocess import PIPE, Popen
from threading import Thread
from queue import Queue, Empty


def enqueue_output(stream, queue):
    for line in iter(stream.readline, b''):
        queue.put(line)
    stream.close()


def run_with_escape_character(process: list, escape_character="q", menu="main"):
    p = Popen(process, stdout=PIPE, stderr=PIPE, bufsize=1)
    q = Queue()
    t = Thread(target=enqueue_output, args=(p.stdout, q))
    t.daemon = True
    t.start()
    kb = KBHit()

    while True:
        if kb.kbhit():
            k_in = getch()
            if k_in == escape_character:
                break
            else:
                print(f'The escape character is {escape_character}.')
                print(f'Press {escape_character} to exit.')

        try:
            line = q.get_nowait()
            line = line.decode("utf-8")
            print(line)
        except Empty:
            continue

    p.terminate()
    t.join()
    return menu
