import click

from snmp_management import edit_snmp_configs, create_multiple_users, get_snmp_status, snmp_restart, snmp_stop, \
    snmp_start, snmp_is_active, is_snmp_enabled, disable_snmp, enable_snmp


def snmp_menu_handler(char, ctx, menu):
    if char == 'b':
        menu = 'autoupdate'

    elif char == '1':
        if is_snmp_enabled():
            ctx.invoke(disable_snmp)
        else:
            ctx.invoke(enable_snmp)
    if is_snmp_enabled():
        if char == '2':
            if snmp_is_active():
                ctx.invoke(snmp_stop)
            else:
                ctx.invoke(snmp_start)

        elif char == '3':
            ctx.invoke(snmp_restart)

        elif char == '4':
            ctx.invoke(get_snmp_status)

        elif char == '5':
            ctx.invoke(create_multiple_users)

        elif char == '6':
            ctx.invoke(edit_snmp_configs)

    return menu


def snmp_menu():
    click.clear()
    click.secho('SNMP Management', fg='green')

    if is_snmp_enabled():
        click.secho('1: Disable SNMP', fg='green')
    else:
        click.secho('1: Enable SNMP', fg='green')

    if is_snmp_enabled():
        if snmp_is_active():
            click.secho('2: Stop SNMP', fg='green')
        else:
            click.secho('2: Start SNMP', fg='green')

        click.secho('3: Restart SNMP', fg='green')
        click.secho('4: View SNMP status', fg='green')
        click.secho('5: Create SNMPv3 user', fg='green')
        click.secho('6: Edit SNMP config', fg='green')

    click.secho('b: Back to Akkadian Appliance Manager Settings', fg='red')
