import click

from ucce_management import ucce_install, ucce_stop, ucce_restart, ucce_start, ucce_status, ucce_rest_api_log, ucce_conn_api_log


def ucce_menu_handler(char, ctx, menu):
    if char == 'b':
        menu = 'main'

    elif char == '1':
        ctx.invoke(ucce_install)

    elif char == '2':
        ctx.invoke(ucce_stop)

    elif char == '3':
        ctx.invoke(ucce_restart)

    elif char == '4':
        ctx.invoke(ucce_start)

    elif char == '5':
        ctx.invoke(ucce_status)

    elif char == '6':
        ctx.invoke(ucce_rest_api_log)

    elif char == '7':
        ctx.invoke(ucce_conn_api_log)


    return menu


def ucce_menu():
    click.clear()
    click.secho('UCCE Service Settings', fg='green')
    click.secho('1: Install/Update UCCE Service', fg='green')
    click.secho('2: Stop UCCE Service', fg='green')
    click.secho('3: Restart UCCE Service', fg='green')
    click.secho('4: Start UCCE Service', fg='green')
    click.secho('5: Status UCCE Service', fg='green')
    click.secho('6: UCCE REST API Log', fg='green')
    click.secho('7: UCCE Connection API Log', fg='green')
    click.secho('b: Back to Main Menu', fg='red')
    click.secho('Once option is selected you can press \'q\' at any time\nto return to back to this menu.', fg='yellow')