from yum_management import (remove_yum_proxy_configuration, set_yum_proxy_configuration, view_yum_proxy_configuration)
import click


def yum_menu_handler(char, ctx, menu):
    try:
        if char == 'b':
            menu = 'network'

        elif char == '1':
            ctx.invoke(view_yum_proxy_configuration)

        elif char == '2':
            ctx.invoke(set_yum_proxy_configuration)

        elif char == '3':
            if click.confirm("Are you sure you want to remove all yum proxy settings?"):
                ctx.invoke(remove_yum_proxy_configuration)

        else:
            click.echo('Invalid input')

    except KeyboardInterrupt:
        menu = 'yum_management'

    return menu


def render_yum_menu():
    click.clear()
    click.secho('Yum Configuration', fg='green')
    click.secho('1: View Yum Proxy Settings', fg='green')
    click.secho('2: Configure Yum Proxy Settings', fg='green')
    click.secho('3: Clear Yum Proxy Settings', fg='green')
    click.secho('b: Back to Network Menu', fg='red')
