from subprocess import Popen, PIPE, run
import configparser

mapper = configparser.RawConfigParser()
mapper.read('mapper.ini')


def is_ssh_enable():
    p = Popen(["sh", mapper.get('GeneralScripts', 'isSshEnable')], stdout=PIPE, stderr=PIPE)

    for line in p.stdout:
        line = line.decode("utf-8")
        if "ssh" in line:
            return True
        elif "False" in line:
            return False


def disable_ssh():
    p = Popen(["sh", mapper.get('GeneralScripts', 'closeSsh')], stdout=PIPE,
              stderr=PIPE)
    return


def enable_ssh():
    p = Popen(["sh", mapper.get('GeneralScripts', 'openSsh')], stdout=PIPE,
              stderr=PIPE)
    return


def enable_root_ssh_access():
    p = Popen(["sh", mapper.get('GeneralScripts', 'permitRootAccessOn')], stdout=PIPE,
              stderr=PIPE)
    return


def disable_root_ssh_access():
    p = Popen(["sh", mapper.get('GeneralScripts', 'permitRootAccessOff')], stdout=PIPE,
              stderr=PIPE)
    return


def is_allow_root_access_on():
    p = Popen(["sh", mapper.get('GeneralScripts', 'isRootAccessOn')], stdout=PIPE,
              stderr=PIPE)
    for line in p.stdout:
        line = line.decode("utf-8")
        if "True" in line:
            return True
        elif "False" in line:
            return False

    return


def port_enabled(port):
    p = run(["bash", mapper.get('NetworkScripts', 'portStatus'), port], stdout=PIPE, stderr=PIPE,
            universal_newlines=True)

    if "True" in p.stdout:
        return True
    elif "False" in p.stdout:
        return False


def open_port(port):
    run(["bash", mapper.get('NetworkScripts', 'openPort'), port], stdout=PIPE, stderr=PIPE, universal_newlines=True)


def close_port(port):
    run(["bash", mapper.get('NetworkScripts', 'closePort'), port], stdout=PIPE, stderr=PIPE, universal_newlines=True)
