
base=/home/akkadianuser/upgrades
scripts=/home/akkadianuser/scripts
packages=/home/akkadianuser/packages
sh $base/apm_installs/queue_daemons.sh
# Moved to finish_update_main.sh AAM-3399
#sh $scripts/apm/remove-security-sensitive-files.sh

# -w searches for an exact match
# -q Quiet; do not write anything to standard output.  Exit immediately with zero status if any match is found, even if an error was detected.
# the echo $? will give me 0 if found and nothing if not found
found=$(grep -wq "python" /usr/local/bin/supervisorctl && echo $?)
if [ "$found" == "0" ]; then
  sed -i 's,#!/usr/bin/python,#!/usr/bin/python3,g' /usr/local/bin/supervisord
  sed -i 's,#!/usr/bin/python,#!/usr/bin/python3,g' /usr/local/bin/supervisorctl
fi

#SERVICE_FILE=/etc/systemd/system/pause-jobs-flush-beanstalk.service
##https://www.linode.com/docs/guides/start-service-at-boot/
#echo "Copying service file to systemd directory" > /home/akkadianuser/logs/beanstalkd-service.log 2>&1
#sudo cp /home/akkadianuser/scripts/beanstalk/pause-jobs-flush-beanstalk.service /etc/systemd/system/
#systemctl daemon-reload
#echo "Starting pause-jobs-flush-beanstalk service" >> /home/akkadianuser/logs/beanstalkd-service.log 2>&1
#systemctl start pause-jobs-flush-beanstalk.service
#echo "Reloading daemon" >> /home/akkadianuser/logs/beanstalkd-service.log 2>&1
#systemctl enable pause-jobs-flush-beanstalk.service
#echo "Enabling recovery service" >> /home/akkadianuser/logs/beanstalkd-service.log 2>&1
#echo "Restarting recovery service" >> /home/akkadianuser/logs/beanstalkd-service.log 2>&1
#systemctl restart pause-jobs-flush-beanstalk

if [ -f /etc/systemd/system/pause-jobs-flush-beanstalk.service ];then
  systemctl stop pause-jobs-flush-beanstalk.service
  systemctl disable pause-jobs-flush-beanstalk.service
  \rm -f /etc/systemd/system/pause-jobs-flush-beanstalk.service
fi

if [ -f /home/akkadianuser/scripts/beanstalk/pause-jobs-flush-beanstalk.service ];then
  \rm -f /home/akkadianuser/scripts/beanstalk/pause-jobs-flush-beanstalk.service
fi

#Rsyslog configuration
# create config file and give it apache ownership.
if [ ! -f "/etc/rsyslog.d/apm_rsyslog.conf" ]; then
  touch /etc/rsyslog.d/apm_rsyslog.conf
  chown apache:root /etc/rsyslog.d/apm_rsyslog.conf #give apache access but maintain root group
  chmod o+rwx /etc/rsyslog.d/apm_rsyslog.conf
fi
# copy watch_rsyslog service and start it. 
if [ -f "/home/akkadianuser/scripts/apm/rsyslog_files/watch_rsyslog.service" ]; then
  cp /home/akkadianuser/scripts/apm/rsyslog_files/watch_rsyslog.service /etc/systemd/system/watch_rsyslog.service
  chmod 0664 /etc/systemd/system/watch_rsyslog.service 
  systemctl daemon-reload
  systemctl start watch_rsyslog.service
fi

# enable service so it starts on boot.
if [ -f "/etc/systemd/system/watch_rsyslog.service" ]; then
  systemctl enable watch_rsyslog.service
fi

apm_cron_content=$(sudo crontab -u akkadianuser -l)
if [[ "$apm_cron_content" != *"backup_supervisor_worker_logs.sh"* ]]; then
    apm_new_cron_content="30 1 * * * sh /home/akkadianuser/scripts/apm/supervisor_files/backup_supervisor_worker_logs.sh"
    (sudo crontab -u akkadianuser -l; echo "$apm_new_cron_content" ) | sudo crontab -u akkadianuser -
fi
if [[ "$apm_cron_content" != *"backup_conapilogs.sh"* ]]; then
    apm_new_cron_content="00 00 * * * sh /home/akkadianuser/scripts/apm/backup_conapilogs.sh"
    (sudo crontab -u akkadianuser -l; echo "$apm_new_cron_content" ) | sudo crontab -u akkadianuser -
fi

#This is to plug the security vulnerability that Sam opened a story for having to do with rendering directory list of apache icons.
autoIndexConfFile="/etc/httpd/conf.d/autoindex.conf"
declarations=$(grep -c " Indexes " $autoIndexConfFile)
if ((declarations == 1)); then
  sed -i 's/ Indexes / /' $autoIndexConfFile
  sh $scripts/restart_apache.sh
fi
