#!/usr/bin/env bash

echo "Adding notes to /etc/environment for proxy setup" >>/var/www/product_update/update.log

if grep -w -q "Configure the web proxy" /etc/environment; then
    echo "Proxy configuration notes already exist in /etc/environment. Exiting." >>/var/www/product_update/update.log
    exit 0
else
    message=$(
        cat <<'EOF'
# Configure the web proxy

# http_proxy="http://proxysrv.company.com:80/"
# https_proxy="https://proxysrv.company.com:443/"

# Configure the web proxy with authentication

# http_proxy="http://my_username:my_password@proxysrv.company.com:80/"
# https_proxy="https://my_username:my_password@proxysrv.company.com:443/"

# Configure the web proxy to exclude local hosts. Exclusions must include CUCM and other local servers.

# no_proxy=".company.local,.domain1.com,host1,host2"

EOF
    )
    echo "Proxy configuration notes do not exist in /etc/environment." >>/var/www/product_update/update.log
    if [[ -s /etc/environment ]]; then
        environment_contents=$(cat /etc/environment)
        echo "Prepending proxy configuration notes to non-empty /etc/environment." >>/var/www/product_update/update.log
        echo "${message}${environment_contents}" >/etc/environment
    else
        echo "Prepending proxy configuration notes to empty /etc/environment." >>/var/www/product_update/update.log
        echo "$message" >/etc/environment
    fi
fi

echo "$message"
