# Please apply your changes into the product pre-script.sh
base="/var/www/product_update/scripts/"

# Modify this script if it has to be applied to all products.

# The code below is needed to install cli in a fresh linux machine
if id -u "akkadianuser" >/dev/null 2>&1; then
    echo 'user exists doing nothing'
else
    # install akkadianuser
    echo $'\n' "Creating akkadianuser..."
    adduser akkadianuser
    echo "akkadianpassword" | passwd --stdin akkadianuser
    gpasswd -a akkadianuser wheel

    echo $'\n' "# Akkadian user configuration" >> /etc/sudoers
    echo "akkadianuser ALL=(ALL) ALL" >> /etc/sudoers
    echo "%akkadianuser   ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers
fi

if ! bash "${base}001_general_prescript.sh"; then
    exit 1
fi

if [[ -d /var/www/html/pme ]]; then
    #list here all pme scripts
    if ! bash "${base}001_aPM_prescript.sh"; then
        exit 1
    fi
fi

if [[ -d /var/www/html/acm ]]; then
    sh $base"001_aCM_prescript.sh"
fi

if [[ -d /var/www/html/orc ]]; then
    sh $base"001_orc_prescript.sh"
fi

if [[ -d /var/www/html/asb ]]; then
    sh $base"001_asb_prescript.sh"
fi

if [[ -d /var/www/html/maestro ]]; then
    sh $base"001_maestro_prescript.sh"
fi

if [[ -d /opt/akkadian/aco-server ]]; then
    sh $base"001_aCO_prescript.sh"
fi

# Here the actions block ends
