function rollback() {
    echo "------------ Rolling back ------------";
    yum -y remove php php-gd php-mcrypt php-fpm php-dom php-mbstring php-cli php-zip;
    yum autoremove;
    exit 1;
}
function check_error() {
    if [ "$1" != 0 ]; then
        echo $2;
        echo "------------ Cause: $1 ------------";
        rollback;
    fi
}
function install() {
    yum -y install $1
    check_error $? "------------ Failed to install $1------------";
}

echo "------------ PHP installation script: BEGIN ------------"

# Here is checking if the installed version is greater than the needed one."
version=$(php --version);
regex="^PHP\s(\d\.\d\.\d*)\s"
if [[ $version =~ regex ]]; then
    if [[ $1 > "7.4" ]]; then
        echo "------------ PHP is already installed ------------"
        exit 0;
    fi
fi


echo "------------ installing yum and common dependencies ------------";
install "yum-utils wget unzip";

echo "------------ Updating Repositories ------------";
install "http://rpms.remirepo.net/enterprise/remi-release-7.rpm https://dl.fedoraproject.org/pub/epel/epel-release-latest-7.noarch.rpm";

echo "------------ enable remi-php7.4 ------------";
yum-config-manager --enable remi-php74;
check_error $? "------------ Failed to enable remi-php74 ------------";

echo "------------ Installing php and dependencies ------------";
install "php php-gd php-mcrypt php-fpm php-dom php-mbstring php-cli php-zip";

echo "------------ Downloading and installing composer ------------";
php -r "copy('https://getcomposer.org/installer', '/root/composer-setup.php');";
php /root/composer-setup.php --install-dir=/usr/local/bin --filename=composer;
check_error $? "------------ Failed to downlod and install composer ------------";

echo "------------ Purgin installation files ------------";
rm /root/composer-setup.php

echo "------------ Checking installation ------------";
php --version | grep "^PHP\s7.4";

if [ ! $? -eq 0 ]; then

    echo "------------ Installation failed, rollingback ------------";
    rollback;
    exit 1;
fi
echo "------------ PHP installation script: END ------------"

yes | cp /home/akkadianuser/upgrades/php_into_acs/env.php /usr/share/nginx/html/update/
yes | cp /home/akkadianuser/upgrades/php_into_acs/www.conf /etc/php-fpm.d/
yes | cp /home/akkadianuser/upgrades/php_into_acs/nginx.conf /etc/nginx/


sudo chown -Rf nginx:nginx /usr/share/nginx/html/update
sudo chmod 766 -Rf /usr/share/nginx/html/update
sudo sh /home/akkadianuser/upgrades/php_into_acs/install-ioncube.sh

yes | sudo cp -Rf  /home/akkadianuser/upgrades/php_into_acs/php-fpm.service /usr/lib/systemd/system/php-fpm.service

sudo systemctl enable php-fpm
sudo systemctl daemon-reload
sudo systemctl restart php-fpm